SystemOrganization addCategory: #'KinectOSC-Morph'!
SystemOrganization addCategory: #'KinectOSC-Basic'!
SystemOrganization addCategory: #'KinectOSC-Tests'!

Morph subclass: #KOJointMorph
	instanceVariableNames: 'jointName skelton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Morph'!

!KOJointMorph methodsFor: 'initialize' stamp: 'EiichiroIto 7/13/2012 18:06'!
initialize
	super initialize.
	self extent: 20 @ 20.
	self color: Color white! !

!KOJointMorph methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 19:20'!
jointName
	^ jointName! !

!KOJointMorph methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 19:20'!
jointName: anObject
	jointName := anObject! !

!KOJointMorph methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 22:15'!
skelton
	^ skelton! !

!KOJointMorph methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 19:19'!
skelton: anObject
	skelton := anObject! !

!KOJointMorph methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 17:38'!
updatePosition
	| joint pos x y baseMorph |
	skelton ifNil: [ ^ self ].
	joint := skelton jointNamed: jointName.
	joint ifNil: [ ^ self ].
	self
		center:
			(owner
				pointFor:
					{(joint x).
					(joint y).
					(joint z)})! !

Morph subclass: #KOSampleMorph
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Morph'!

!KOSampleMorph methodsFor: 'submorphs-add/remove' stamp: 'EiichiroIto 8/27/2012 15:46'!
createSkelton: aSkelton
	| morph |
	morph := self newSkeltonMorph.
	morph skelton: aSkelton.
	self addMorphBack: morph! !

!KOSampleMorph methodsFor: 'submorphs-add/remove' stamp: 'EiichiroIto 7/10/2012 22:32'!
delete
	controller stop.
	super delete! !

!KOSampleMorph methodsFor: 'submorphs-add/remove' stamp: 'EiichiroIto 7/11/2012 21:02'!
deleteSkelton: aSkelton
	submorphs
		do: [ :each | 
			each skelton = aSkelton
				ifTrue: [ each delete ] ]! !

!KOSampleMorph methodsFor: 'initialize' stamp: 'EiichiroIto 7/13/2012 19:30'!
initialize
	super initialize.
	self extent: 480 @ 480.
	self color: Color red.
	controller := KinectOSC new.
	controller createSkeltonBlock: [ :skel | self createSkelton: skel ].
	controller deleteSkeltonBlock: [ :skel | self deleteSkelton: skel ].
	controller start! !

!KOSampleMorph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 15:46'!
newSkeltonMorph
	^ KOSkeltonMorph new! !

!KOSampleMorph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 16:07'!
pointFor: anArray
	| x y |
	x := (anArray at: 1) * (self width - 40) + 20.
	y := (anArray at: 2) * (self height - 40) + 20.
	^ self topLeft + (x @ y)! !

!KOSampleMorph methodsFor: 'stepping and presenter' stamp: 'EiichiroIto 8/27/2012 15:12'!
step
	self submorphs do: [ :each | each step ].
	self updateColor! !

!KOSampleMorph methodsFor: 'testing' stamp: 'EiichiroIto 7/11/2012 20:56'!
stepTime
	^ 250! !

!KOSampleMorph methodsFor: 'private' stamp: 'EiichiroIto 7/10/2012 20:42'!
updateColor
	self
		color:
			(controller isEmpty
				ifTrue: [ Color red ]
				ifFalse: [ Color green ])! !

!KOSampleMorph methodsFor: 'testing' stamp: 'EiichiroIto 7/9/2012 22:34'!
wantsSteps
	^ true! !

Morph subclass: #KOSkeltonMorph
	instanceVariableNames: 'skelton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Morph'!

!KOSkeltonMorph methodsFor: 'drawing' stamp: 'EiichiroIto 8/28/2012 09:47'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas drawString: 'User' , skelton id asString at: self topLeft! !

!KOSkeltonMorph methodsFor: 'initialize' stamp: 'EiichiroIto 8/27/2012 15:16'!
initialize
	super initialize.
	self extent: 20 @ 50.
	self color: Color gray! !

!KOSkeltonMorph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 15:09'!
newJointMorph
	^ KOJointMorph new! !

!KOSkeltonMorph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 17:38'!
pointFor: anArray
	^ owner pointFor: anArray! !

!KOSkeltonMorph methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 15:08'!
skelton
	^ skelton! !

!KOSkeltonMorph methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 15:08'!
skelton: anObject
	skelton := anObject! !

!KOSkeltonMorph methodsFor: 'stepping and presenter' stamp: 'EiichiroIto 8/27/2012 17:39'!
step
	self updateJointMorphs.
	self updateBounds! !

!KOSkeltonMorph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 16:18'!
updateBounds
	self submorphs isEmpty
		ifTrue: [  ]
		ifFalse: [ 
			| rect |
			rect := self submorphs inject: submorphs first bounds into: [ :prev :each | prev merge: each bounds ].
			self bounds: rect ]! !

!KOSkeltonMorph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 15:55'!
updateJointMorphs
	| newJoints rect |
	newJoints := skelton joints asOrderedCollection collect: [ :each | each name ].
	newJoints := newJoints \ (self submorphs collect: [ :each | each jointName ]).
	newJoints
		do: [ :each | 
			| morph |
			morph := self newJointMorph.
			morph
				skelton: skelton;
				jointName: each.
			self addMorphBack: morph ].
	self submorphs do: [ :each | each updatePosition ]! !

TestCase subclass: #KOJointTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Tests'!

!KOJointTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 19:07'!
testName
	| j1 j2 |
	j1 := KOJoint new.
	j2 := KOJoint new.
	j1 name: 'l_hand'.
	j2 name: 'l_elbow'.
	self assert: j1 name = 'l_hand'.
	self assert: j2 name = 'l_elbow'! !

!KOJointTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 19:07'!
testNameXYZ
	| j |
	j := KOJoint
		name: 'l_elbow'
		x: 0.8395442366600037
		y: 0.7878888249397278
		z: 1.2370036840438843.
	self assert: j name = 'l_elbow'.
	self assert: j x = 0.8395442366600037.
	self assert: j y = 0.7878888249397278.
	self assert: j z = 1.2370036840438843! !

!KOJointTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 18:40'!
testX
	| j1 j2 |
	j1 := KOJoint new.
	j2 := KOJoint new.
	j1 x: 1.
	j2 x: 2.
	self assert: j1 x = 1.
	self assert: j2 x = 2! !

!KOJointTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 18:40'!
testY
	| j1 j2 |
	j1 := KOJoint new.
	j2 := KOJoint new.
	j1 y: 1.
	j2 y: 2.
	self assert: j1 y = 1.
	self assert: j2 y = 2! !

!KOJointTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 18:40'!
testZ
	| j1 j2 |
	j1 := KOJoint new.
	j2 := KOJoint new.
	j1 z: 1.
	j2 z: 2.
	self assert: j1 z = 1.
	self assert: j2 z = 2! !

TestCase subclass: #KOModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Tests'!

!KOModelTest methodsFor: 'tests' stamp: 'EiichiroIto 7/11/2012 21:30'!
testDeleteUserID
	| model skelton |
	model := KOModel new.
	model newUserID: 1.
	self assert: (model includesID: 1).
	model deleteUserID: 1.
	self deny: (model includesID: 1)! !

!KOModelTest methodsFor: 'tests' stamp: 'EiichiroIto 8/29/2012 09:06'!
testIsEmpty
	| model skelton |
	model := KOModel new.
	self assert: model isEmpty.
	model newUserID: 1.
	self deny: model isEmpty.
	model newUserID: 2.
	self deny: model isEmpty.
	model deleteUserID: 1.
	self deny: model isEmpty.
	model deleteUserID: 2.
	self assert: model isEmpty! !

!KOModelTest methodsFor: 'tests' stamp: 'EiichiroIto 7/11/2012 21:29'!
testNewUserID
	| model skelton |
	model := KOModel new.
	self deny: (model includesID: 1).
	model newUserID: 1.
	self assert: (model includesID: 1).
	skelton := model skeltonForUserID: 1.
	self assert: (skelton isKindOf: KOSkelton).
	self assert: skelton isEmpty! !

!KOModelTest methodsFor: 'tests' stamp: 'EiichiroIto 7/11/2012 21:31'!
testSkeltonForUserID
	| model skelton |
	model := KOModel new.
	self deny: (model includesID: 1).
	skelton := model skeltonForUserID: 1.
	self assert: (model includesID: 1).
	self assert: (skelton isKindOf: KOSkelton).
	self assert: skelton isEmpty! !

!KOModelTest methodsFor: 'tests' stamp: 'EiichiroIto 8/29/2012 09:11'!
testUpdatePosition
	| model skelton |
	model := KOModel new.
	model newUserID: 1.
	model newUserID: 2.
	model
		updatePosition:
			{10.
			20.
			30}
		id: 1.
	model
		updatePosition:
			{40.
			50.
			60}
		id: 2.
	skelton := model skeltonForUserID: 1.
	self assert: (skelton position at: 1) = 10.
	self assert: (skelton position at: 2) = 20.
	self assert: (skelton position at: 3) = 30.
	skelton := model skeltonForUserID: 2.
	self assert: (skelton position at: 1) = 40.
	self assert: (skelton position at: 2) = 50.
	self assert: (skelton position at: 3) = 60! !

TestCase subclass: #KOSkeltonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Tests'!

!KOSkeltonTest methodsFor: 'private' stamp: 'EiichiroIto 7/9/2012 19:29'!
sampleJoint1
	^ KOJoint
		name: 'l_elbow'
		x: 0.8395442366600037
		y: 0.7878888249397278
		z: 1.2370036840438843! !

!KOSkeltonTest methodsFor: 'private' stamp: 'EiichiroIto 7/9/2012 19:29'!
sampleJoint2
	^ KOJoint
		name: 'l_hand'
		x: 0.7466590404510498
		y: 0.7462562918663025
		z: 1.165597915649414! !

!KOSkeltonTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 23:07'!
testAddJoint
	| j1 j2 skel j |
	j1 := self sampleJoint1.
	j2 := self sampleJoint2.
	skel := KOSkelton new.
	skel addJoint: j1.
	skel addJoint: j2.
	j := skel jointNamed: 'l_elbow'.
	self assert: j1 = j.
	self deny: j2 = j.
	j := skel jointNamed: 'l_hand'.
	self deny: j1 = j.
	self assert: j2 = j! !

!KOSkeltonTest methodsFor: 'tests' stamp: 'EiichiroIto 8/28/2012 09:08'!
testId
	| skel1 skel2 |
	skel1 := KOSkelton new.
	skel2 := KOSkelton new.
	skel1 id: 1.
	skel2 id: 2.
	self assert: skel1 id = 1.
	self assert: skel2 id = 2! !

!KOSkeltonTest methodsFor: 'tests' stamp: 'EiichiroIto 8/29/2012 09:13'!
testIsEmpty
	| j1 j2 skel j |
	j1 := self sampleJoint1.
	j2 := self sampleJoint2.
	skel := KOSkelton new.
	self assert: skel isEmpty.
	skel addJoint: j1.
	self deny: skel isEmpty.
	skel addJoint: j2.
	self deny: skel isEmpty! !

!KOSkeltonTest methodsFor: 'tests' stamp: 'EiichiroIto 7/9/2012 23:05'!
testJointNamed
	| j1 skel |
	j1 := self sampleJoint1.
	skel := KOSkelton new.
	skel addJoint: j1.
	self assert: (skel jointNamed: 'l_elbow') = j1.
	self assert: (skel jointNamed: 'l_hand') isNil! !

!KOSkeltonTest methodsFor: 'tests' stamp: 'EiichiroIto 8/29/2012 09:15'!
testPosition
	| skel |
	skel := KOSkelton new.
	skel
		position:
			{10.
			20.
			30}.
	self assert: (skel position at: 1) = 10.
	self assert: (skel position at: 2) = 20.
	self assert: (skel position at: 3) = 30.
	skel
		position:
			{40.
			50.
			60}.
	self assert: (skel position at: 1) = 40.
	self assert: (skel position at: 2) = 50.
	self assert: (skel position at: 3) = 60! !

TestCase subclass: #KinectOSCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Tests'!

!KinectOSCTest methodsFor: 'tests' stamp: 'EiichiroIto 7/13/2012 19:26'!
testIsEmpty
	| controller |
	controller := KinectOSC new.
	self assert: controller isEmpty! !

!KinectOSCTest methodsFor: 'tests' stamp: 'EiichiroIto 7/13/2012 19:26'!
testProcessBundleMessage
	| skel controller msg model |
	msg := #('/joint' 'head' 1 0.547346 0.121233 1.77051).
	controller := KinectOSC new.
	controller processBundleMessage: msg.
	model := controller model.
	skel := model skeltonForUserID: 1.
	self assert: (skel jointNamed: #head) x = 0.547346.
	self assert: (skel jointNamed: #head) y = 0.121233.
	self assert: (skel jointNamed: #head) z = 1.77051! !

!KinectOSCTest methodsFor: 'tests' stamp: 'EiichiroIto 7/13/2012 19:26'!
testProcessJoint
	| skel controller msg model |
	msg := #('/joint' 'head' 1 0.547346 0.121233 1.77051).
	controller := KinectOSC new.
	controller processJoint: msg.
	model := controller model.
	skel := model skeltonForUserID: 1.
	self assert: (skel jointNamed: #head) x = 0.547346.
	self assert: (skel jointNamed: #head) y = 0.121233.
	self assert: (skel jointNamed: #head) z = 1.77051! !

!KinectOSCTest methodsFor: 'tests' stamp: 'EiichiroIto 7/13/2012 19:26'!
testReceiveOSCMessage
	| skel controller msg model |
	msg := #('/new_user' 1).
	controller := KinectOSC new.
	model := controller model.
	self assert: model isEmpty.
	controller receiveOSCMessage: msg.
	self assert: (model includesID: 1).
	msg := #('/lost_user' 1).
	controller receiveOSCMessage: msg.
	self deny: (model includesID: 1)! !

Object subclass: #KOJoint
	instanceVariableNames: 'x y z name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Basic'!

!KOJoint class methodsFor: 'instance creation' stamp: 'EiichiroIto 7/9/2012 19:07'!
name: aString x: x y: y z: z
	| obj |
	obj := self new.
	obj
		name: aString;
		x: x;
		y: y;
		z: z.
	^ obj! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 19:06'!
name
	^ name! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 19:06'!
name: anObject
	name := anObject! !

!KOJoint methodsFor: 'printing' stamp: 'EiichiroIto 7/9/2012 19:06'!
printOn: aStream
	aStream
		nextPutAll: name;
		nextPut: $(;
		nextPutAll: x asString;
		nextPut: $,;
		nextPutAll: y asString;
		nextPut: $,;
		nextPutAll: z asString;
		nextPut: $)! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 18:34'!
x
	^ x! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 18:34'!
x: anObject
	x := anObject! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 18:34'!
y
	^ y! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 18:34'!
y: anObject
	y := anObject! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 18:34'!
z
	^ z! !

!KOJoint methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 18:34'!
z: anObject
	z := anObject! !

Object subclass: #KOModel
	instanceVariableNames: 'skeltons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Basic'!

!KOModel methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 10:36'!
deleteUserID: aNumber
	^ skeltons removeKey: aNumber ifAbsent: [  ]! !

!KOModel methodsFor: 'testing' stamp: 'EiichiroIto 8/27/2012 10:36'!
includesID: aNumber
	^ skeltons includesKey: aNumber! !

!KOModel methodsFor: 'initialize-release' stamp: 'EiichiroIto 8/27/2012 10:36'!
initialize
	skeltons := Dictionary new! !

!KOModel methodsFor: 'testing' stamp: 'EiichiroIto 8/27/2012 10:36'!
isEmpty
	^ skeltons isEmpty! !

!KOModel methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 09:06'!
newUserID: aNumber
	skeltons at: aNumber put: (KOSkelton id: aNumber)! !

!KOModel methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 09:06'!
skeltonForUserID: aNumber
	^ skeltons at: aNumber ifAbsentPut: [ KOSkelton id: aNumber ]! !

!KOModel methodsFor: 'accessing' stamp: 'EiichiroIto 7/10/2012 20:23'!
updateJoint: aJoint id: aNumber firstTimeDo: aBlock
	| skel |
	skel := self skeltonForUserID: aNumber.
	skel isEmpty
		ifTrue: [ aBlock value: skel ].
	skel addJoint: aJoint! !

!KOModel methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 15:59'!
updatePosition: anArray id: aNumber
	| skel |
	skel := self skeltonForUserID: aNumber.
	skel position: anArray! !

Object subclass: #KOSkelton
	instanceVariableNames: 'id joints position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Basic'!

!KOSkelton class methodsFor: 'as yet unclassified' stamp: 'EiichiroIto 8/28/2012 09:06'!
id: aNumber
	^ self new
		id: aNumber;
		yourself! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 23:05'!
addJoint: aJoint
	joints at: aJoint name asSymbol put: aJoint! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 09:05'!
id
	^ id! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 09:05'!
id: anObject
	id := anObject! !

!KOSkelton methodsFor: 'initialize-release' stamp: 'EiichiroIto 8/27/2012 15:14'!
initialize
	joints := Dictionary new.
	position := {0.5.
	0.5.
	1.0}! !

!KOSkelton methodsFor: 'testing' stamp: 'EiichiroIto 7/10/2012 20:23'!
isEmpty
	^ joints isEmpty! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 19:27'!
jointNamed: aString
	^ joints at: aString ifAbsent: [ nil ]! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 8/29/2012 09:15'!
jointNames
	"For reference, not used."

	^ #(#head #neck #torso #r_shoulder #r_elbow #r_hand #l_shoulder #l_elbow #l_hand #r_hip #r_knee #r_ankle #r_foot #l_hip #l_knee #l_ankle #l_foot)! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 15:17'!
joints
	^ joints copy! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 16:00'!
position
	^ position copy! !

!KOSkelton methodsFor: 'accessing' stamp: 'EiichiroIto 8/27/2012 15:59'!
position: anArray
	position := anArray! !

Object subclass: #KinectOSC
	instanceVariableNames: 'server model createSkeltonBlock deleteSkeltonBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectOSC-Basic'!

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/13/2012 19:28'!
createSkeltonBlock: anObject
	createSkeltonBlock := anObject! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/10/2012 22:33'!
defaultOSCPort
	^ 7110! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/13/2012 19:28'!
deleteSkeltonBlock: anObject
	deleteSkeltonBlock := anObject! !

!KinectOSC methodsFor: 'initialize-release' stamp: 'EiichiroIto 7/10/2012 18:07'!
initialize
	model := KOModel new! !

!KinectOSC methodsFor: 'testing' stamp: 'EiichiroIto 7/10/2012 20:42'!
isEmpty
	^ model isEmpty! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/10/2012 22:17'!
model
	^ model! !

!KinectOSC methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 15:57'!
processBundleMessage: aMessage
	| address |
	address := aMessage first.
	address = '/joint'
		ifTrue: [ ^ self processJoint: aMessage ].
	(address beginsWith: '/user/')
		ifTrue: [ ^ self processUser: aMessage ]! !

!KinectOSC methodsFor: 'private' stamp: 'EiichiroIto 7/9/2012 23:08'!
processJoint: aMessage
	| jointName id x y z skel joint jointNames |
	jointName := (aMessage at: 2) asSymbol.
	id := aMessage at: 3.
	x := aMessage at: 4.
	y := aMessage at: 5.
	z := aMessage at: 6.
	joint := KOJoint
		name: jointName
		x: x
		y: y
		z: z.
	self updateJoint: joint id: id! !

!KinectOSC methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 15:58'!
processUser: aMessage
	| address id x y z skel joint jointNames |
	address := aMessage first.
	id := (address copyReplaceAll: '/user/' with: '') asNumber.
	x := aMessage at: 2.
	y := aMessage at: 3.
	z := aMessage at: 4.
	self
		updatePosition:
			{x.
			y.
			z}
		id: id! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/9/2012 21:54'!
receiveBundleMessage: anBundleMessage
	anBundleMessage flattened do: [ :each | self processBundleMessage: each ]! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/13/2012 19:29'!
receiveOSCMessage: anOSCMessage
	| address id |
	address := anOSCMessage first.
	id := anOSCMessage second.
	address = '/new_user'
		ifTrue: [ model newUserID: id ].
	address = '/lost_user'
		ifTrue: [ 
			| skel |
			skel := model deleteUserID: id.
			deleteSkeltonBlock ifNotNil: [ deleteSkeltonBlock value: skel ] ].
	address = '/new_skel'
		ifTrue: [  ]! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/10/2012 22:33'!
start
	self startOn: self defaultOSCPort! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/10/2012 22:31'!
startOn: aNumber
	server := OSCServer listenOnPort: aNumber.
	server when: #messageReceived evaluate: [ :msg | self receiveOSCMessage: msg ].
	server when: #bundleReceived evaluate: [ :msg | self receiveBundleMessage: msg ]! !

!KinectOSC methodsFor: 'accessing' stamp: 'EiichiroIto 7/10/2012 22:32'!
stop
	server terminate! !

!KinectOSC methodsFor: 'private' stamp: 'EiichiroIto 7/13/2012 19:29'!
updateJoint: aJoint id: aNumber
	model
		updateJoint: aJoint
		id: aNumber
		firstTimeDo: [ :skel | createSkeltonBlock ifNotNil: [ createSkeltonBlock value: skel ] ]! !

!KinectOSC methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 15:59'!
updatePosition: anArray id: aNumber
	model updatePosition: anArray id: aNumber! !
